Subject: Re: [BUG] VPN broken in net-next

From: Stephen Hemminger <[email-masked]>
Date: Thu, 3 Mar 2011 13:54:56 -0800

On Thu, 03 Mar 2011 11:23:28 -0800 (PST)
David Miller <[email-masked]> wrote:

> From: Julian Anastasov <[email-masked]>
> Date: Thu, 3 Mar 2011 15:09:22 +0200 (EET)
> 
> > On Thu, 3 Mar 2011, Julian Anastasov wrote:
> > 
> >> 	May be the problem is in inet_hash_insert(), it should
> >> hash ifa_local, not ifa_address. May be they are equal for
> > 
> > 	... and of course the new __ip_dev_find should use
> > ifa_local too.
> 
> Thanks for looking into this Julian.  I will look at the other
> cases you found later.
> 
> Stephen, is this sufficient to fix your problem?  I suspect it is
> not because fib_add_addr() adds prefixes with RTN_LOCAL to the
> local routing table too :-/
> 
> I suspect that even if we need to handle prefixes, we can still use
> the hash for optimistic lookup, and fallback to a local table FIB
> inspection if that fails.
> 
> --------------------
> ipv4: Fix __ip_dev_find() to use ifa_local instead of ifa_address.
> 
> Reported-by: Stephen Hemminger <[email-masked]>
> Reported-by: Julian Anastasov <[email-masked]>
> Signed-off-by: David S. Miller <[email-masked]>
> 

VPN works now with this patch on net-next.